#line 370 "GRCPrinter.nw"
#include "IR.hpp"
#include "AST.hpp"
#include "GRCPrinter.hpp"
#include <iostream>
#include <stdlib.h>

int main()
{
  try {
    IR::XMListream r(std::cin);
    IR::Node *n;
    r >> n;

    AST::Modules *mods = dynamic_cast<AST::Modules*>(n);
    if (!mods) throw IR::Error("Root node is not a Modules object");

    for ( std::vector<AST::Module*>::iterator i = mods->modules.begin() ;
	  i != mods->modules.end() ; i++ ) {
      assert(*i);

      AST::GRCgraph *g = dynamic_cast<AST::GRCgraph*>((*i)->body);
      if (!g) throw IR::Error("Module is not in GRC format");

      AST::GRCDot(std::cout, g, *i);
    }
  } catch (IR::Error &e) {
    std::cerr << e.s << std::endl;
    exit(-1);
  }
  return 0;
}
